import * as React from "react";
import * as PT from "prop-types";
import "nav-frontend-toggle-style";
export interface ToggleKnappPureProps extends React.HTMLAttributes<HTMLButtonElement> {
    /**
     * Content
     */
    children?: React.ReactNode;
    /**
     * Pressed state
     */
    pressed?: boolean;
    /**
     * Kompakt versjon
     */
    kompakt?: boolean;
    /**
     * onClick callback
     */
    onClick?: (event: React.MouseEvent<HTMLButtonElement>) => void;
}
declare class ToggleKnappPure extends React.PureComponent<ToggleKnappPureProps> {
    static defaultProps: ToggleKnappPureProps;
    render(): JSX.Element;
}
export declare const ToggleKnappPurePropsShape: PT.Validator<PT.InferProps<{
    /**
     * Content
     */
    children: PT.Requireable<string | number | boolean | {} | PT.ReactElementLike | PT.ReactNodeArray>;
    /**
     * Pressed state
     */
    pressed: PT.Requireable<boolean>;
    /**
     * Kompakt versjon
     */
    kompakt: PT.Requireable<boolean>;
    /**
     * Custom onChange handler
     */
    onChange: PT.Requireable<(...args: any[]) => any>;
}>>;
export default ToggleKnappPure;
